let dotsArray = []; // Array to hold the dot objects

function setup() {
    createCanvas(710, 400);
    noFill();
    stroke(255);

    // Create objects
    for (let i = 0; i < 50; i++) {
        let ellipseObj = {
            x: random(width), // Random initial x position
            y: random(height), // Random initial y position
            diameter: random(10, 50), // Random diameter
            speedX: random(-2, 2), // Random horizontal speed
            speedY: random(-2, 2), // Random vertical speed
            color: color(random(255), random(255), random(255)) // Random color for each dot
        };
        dotsArray.push(ellipseObj); // Add the created object to the array
    }
    console.log(dotsArray); // Log the initialized dots Array
}

function draw() {
    background(0); // Dark background for visibility

    // Draw all the dots on each frame, moving their positions
    for (let i = 0; i < dotsArray.length; i++) {
        let ellipseObj = dotsArray[i];

        // Move the ellipse
        ellipseObj.x += ellipseObj.speedX;
        ellipseObj.y += ellipseObj.speedY;

        // Check boundaries and bounce back
        if (ellipseObj.x < 0 || ellipseObj.x > width) {
            ellipseObj.speedX *= -1; // Reverse speed
            ellipseObj.color = color(random(255), random(255), random(255)); // Change color on bounce
        }
        if (ellipseObj.y < 0 || ellipseObj.y > height) {
            ellipseObj.speedY *= -1; // Reverse speed
            ellipseObj.color = color(random(255), random(255), random(255)); // Change color on bounce
        }

        // Draw the ellipse
        fill(ellipseObj.color); // Set fill to the object's color
        ellipse(ellipseObj.x, ellipseObj.y, ellipseObj.diameter);
    }
}
